# -*- coding: utf-8 -*- 

import pyopencl as cl
import pyopencl.array as cl_array
import numpy
import opencl

ctx = cl.create_some_context()
queue = cl.CommandQueue(ctx)

def str2numpyint(s):
 sa=[]
 for i in range(len(s)):
   sa.append(   ord(s[i])   )
 return numpy.array(sa , dtype= numpy.uint8)

password = "password"
lenpassword = len(password)

passwordSalt = "12345678901234567890123" # BUG APPEARS IF LENGTH OF THIS STRING IS > 23

lenpasswordSalt = len(passwordSalt)
passwordIterations = 1
keyBytes = 16

numpy_pass_global = str2numpyint(password)
numpy_pass_global_len = numpy.uint32(lenpassword)
numpy_salt = str2numpyint(passwordSalt)
numpy_saltlen = numpy.uint32(lenpasswordSalt)
numpy_passwordIterations = numpy.uint32(passwordIterations) 
numpy_out_global_len = numpy.uint32(keyBytes)

AR_out_global =[] 
for i in range(keyBytes):
   AR_out_global.append(0)
numpy_out_global = numpy.array(AR_out_global , dtype= numpy.uint8) 

mf = cl.mem_flags
pass_global_buf = cl.Buffer(ctx, mf.READ_ONLY, numpy_pass_global.nbytes)
salt_buf        = cl.Buffer(ctx, mf.READ_ONLY, numpy_salt.nbytes)
out_global_buf  = cl.Buffer(ctx, cl.mem_flags.WRITE_ONLY, numpy_out_global.nbytes)

f = open("pbkdf2_hmac_sha1_unsplit_kernel.cl", 'r')
fstr = "".join(f.readlines())

prg = cl.Program(ctx, fstr).build()

cl.enqueue_copy(queue, pass_global_buf, numpy_pass_global, is_blocking=True)
cl.enqueue_copy(queue, salt_buf, numpy_salt, is_blocking=True)

from time import clock
clbegin = clock()

prg.pbkdf2(queue, (1,), None, pass_global_buf, numpy_pass_global_len, salt_buf, numpy_saltlen, numpy_passwordIterations, out_global_buf,numpy_out_global_len )

cl.enqueue_copy(queue, numpy_out_global, out_global_buf).wait()

clend = clock()
opencl_key = ''.join(x.encode('hex') for x in numpy_out_global.tostring())
print "(GPU) PBKDFv2 OpenCL output : "+str(opencl_key)  # <=========== 
print "(GPU) PBKDFv2 OpenCL time   :"+str(clend-clbegin)


